MacroOptions = { }
MacroOptions[1] = false
MacroOptions[2] = false
MacroOptions[3] = false
MacroOptions[4] = false
MacroOptions[5] = false
MacroOptions[6] = false
MacroOptions[7] = true
MacroOptions[8] = false
MacroOptions["M8"] = { }
MacroOptions["Text"] = "1, 2, 3, 4, 5"
MacroOptions["Decolog"] = { }
MacroOptions["M7"] = { }
MacroOptions["M3"] = { }
MacroOptions["M2"] = { }
MacroOptions["Main"] = { }
MacroOptions["Main"]["BusSpeed"] = 115200
MacroOptions["Main"]["AutoSave"] = false
MacroOptions["Main"]["CycleTime"] = 30
MacroOptions["Main"]["FileDevices"] = { }
MacroOptions["Main"]["FileDevices"][1] = { }
MacroOptions["Main"]["FileDevices"][1]["ID"] = "X"
MacroOptions["Main"]["FileDevices"][1]["Name"] = "X2"
MacroOptions["Main"]["FileDevices"][1]["Address"] = 2
MacroOptions["Main"]["FileDevices"][2] = { }
MacroOptions["Main"]["FileDevices"][2]["ID"] = "Y"
MacroOptions["Main"]["FileDevices"][2]["Name"] = "Y3"
MacroOptions["Main"]["FileDevices"][2]["Address"] = 3
MacroOptions["Main"]["FileDevices"][3] = { }
MacroOptions["Main"]["FileDevices"][3]["ID"] = "Z"
MacroOptions["Main"]["FileDevices"][3]["Name"] = "Z4"
MacroOptions["Main"]["FileDevices"][3]["Address"] = 4
MacroOptions["Main"]["BusTimeout"] = 20
MacroOptions["Main"]["Devices"] = "all"
MacroOptions["Load"] = { }
MacroOptions["Load"]["BusSpeed"] = 1250000
MacroOptions["Load"]["AutoSave"] = false
MacroOptions["Load"]["BusTimeout"] = 20
MacroOptions["Load"]["CycleTime"] = 30
MacroOptions["Load"]["Devices"] = "all"
MacroOptions["M4"] = { }
MacroOptions["Decolog_copy"] = { }
MacroOptions["M6"] = { }
MacroOptions["Slider"] = 1


MacroOptionsAux = { }
MacroOptionsAux[1] = { }
MacroOptionsAux[1]["Caption"] = "C1"
MacroOptionsAux[1]["Hint"] = "App.Option[1]"
MacroOptionsAux[2] = { }
MacroOptionsAux[2]["Caption"] = "C2"
MacroOptionsAux[2]["Hint"] = "App.Option[2]"
MacroOptionsAux[3] = { }
MacroOptionsAux[3]["Caption"] = "C3"
MacroOptionsAux[3]["Hint"] = "App.Option[3]"
MacroOptionsAux[4] = { }
MacroOptionsAux[4]["Caption"] = "C4"
MacroOptionsAux[4]["Hint"] = "App.Option[4]"
MacroOptionsAux[5] = { }
MacroOptionsAux[5]["Caption"] = "R1"
MacroOptionsAux[5]["Hint"] = "Log all messages"
MacroOptionsAux[6] = { }
MacroOptionsAux[6]["Caption"] = "R2"
MacroOptionsAux[6]["Hint"] = "Log all but debug messages"
MacroOptionsAux[7] = { }
MacroOptionsAux[7]["Caption"] = "R3"
MacroOptionsAux[7]["Hint"] = "Log errors and warnings"
MacroOptionsAux[8] = { }
MacroOptionsAux[8]["Caption"] = "R4"
MacroOptionsAux[8]["Hint"] = "Log errors only"
MacroOptionsAux["Slider"] = { }
MacroOptionsAux["Slider"]["Hint"] = "App.Option.Slider"
MacroOptionsAux["Text"] = { }
MacroOptionsAux["Text"]["Hint"] = "Comma separated list of axis names or adresses"


Macros = {

{ Name = "M0", Body =
[==================================================[
-- Called before a macro is run

App.OptionInfo.Text.Hint    = nil
App.OptionInfo.Slider.Hint  = nil
App.OptionInfo[1].Hint      = nil
App.OptionInfo[2].Hint      = nil
App.OptionInfo[3].Hint      = nil
App.OptionInfo[4].Hint      = nil
App.OptionInfo[5].Hint      = "Log all messages"
App.OptionInfo[6].Hint      = "Log all but debug messages"
App.OptionInfo[7].Hint      = "Log errors and warnings"
App.OptionInfo[8].Hint      = "Log errors only"

debug.set_debug_level()
UI.Title = __MACRONAME
UI:Position(0.5, 0, 1, 1)

-- Create a global table Option for the current macro's persistent settings.
App.Option[__MACRONAME] = App.Option[__MACRONAME] or {}
Option = App.Option[__MACRONAME]

]==================================================];
Options ={
};

};

{ Name = "Main", Body =
[==================================================[
-- ATB Tester 1.1.0

-- 1.1.0 (2021-02-01)
---------------------
-- Add other commands than PING to the test.

-- 1.0.0
--------
-- Initial version

App.OptionInfo.Text.Hint    = "Comma separated list of axis names or adresses"


--------------------------------------------------------------------------------------
-- Persistent options

Option.AutoSave     = Option.AutoSave or false -- auto save the report
Option.BusSpeed     = Option.BusSpeed or M.BusSpeed
Option.BusTimeout   = 20
Option.CycleTime    = 30    -- minimum cycle time in ms (adjusted to multiples of 15.6 ms)
Option.Devices      = Option.Devices or "all" --, "list" or "file"
Option.FileDevices  = Option.FileDevices or nil


--------------------------------------------------------------------------------------
-- GUI definition

local SP0 = 5       -- tight spacing/padding
local SP1 = 8       -- normal spacing/padding
local SP2 = 12      -- loose spacing/padding
local SP3 = 16      -- very loose spacing/padding

GUI.LabelFont       = "Segoe UI";
GUI.LabelFontSize   = 12;
GUI:Init()
local ocol = GUI:OutlineColor("normal"):clone()

GUI:New()
  :Style{"sep", color = ocol}
  :Style{"nob", border = false}
  :VBox("root", "fill", "fill"):Style{padding = SP3, spacing = SP2}

GUI:Add("root")
  :HBox(nil, "fill", 27):Style{spacing = SP1}
    :Button("save", 120, "fill", nil, nil, "Save report"):Parent()
    :Check("auto-save", 31, "fill", nil, nil, "%", "Auto-save the report")
      :Style{font = "Icons", font_size = 16, padding_left = 6}
      :Down(Option.AutoSave)
      :Parent()
    :Spacer(nil, "100%%"):Parent()
    :Button("stop", 31, "fill", nil, nil, "Z")
      :Style{font = "Icons", font_size = 15, padding_left = 7}
      :Parent()
    :HBox("bus-speed", 31+101*4, "fill"):Style{spacing = 0*SP1, border = ocol}
      :Label("start", 31, "fill", nil, nil, "X")
        :Style{font = "Icons", font_size = 16, padding_left = 3, color = ocol}
        :Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Radio(nil, 100, "fill"):Tag("baud", 115200):Style{"nob"}:Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Radio(nil, 100, "fill"):Tag("baud", 375000):Style{"nob"}:Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Radio(nil, 100, "fill"):Tag("baud", 750000):Style{"nob"}:Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Radio(nil, "100%%", "fill"):Tag("baud", 1250000):Style{"nob"}:Parent()
      :Parent()
    :Spacer(nil, SP3):Parent()
    :HBox("devices", 31+61*3, "fill"):Style{spacing = 0*SP1, border = ocol}
      :Label(nil, 31, "fill", nil, nil, ">")
        :Style{font = "Icons", font_size = 17, padding_left = 3, color = ocol}
        :Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Check(nil, 60, "fill", nil, nil, "All", "All axes"):Tag("value", "all"):Style{"nob"}:Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Check(nil, 60, "fill", nil, nil, "List", "Selected axes"):Tag("value", "list"):Style{"nob"}:Parent()
      :Separator(nil, 1):Style{"sep"}:Parent()
      :Check(nil, "100%%", "fill", nil, nil, "File", "Load axes from an INI file"):Tag("value", "file"):Style{"nob"}:Parent()
      :Parent()
    :Parent()
  :Separator(nil, 1):Style{"sep"}:Parent()
  :Canvas("plot", "fill", "100%%"):Parent()
GUI:End()

local Plot = GUI:Find("plot")
Plot.Meta = {}


--------------------------------------------------------------------------------------

local axes    -- table with axes on test
local stat    -- table with collected data


-- Prepare the axes and clear the collected data
local function reset_stat()
  if Option.Devices == "all" then
    axes = {}
    for a = 1, 31 do table.insert(axes, a) end

  elseif Option.Devices == "list" then
    axes = loadstring("return {"..App.Option.Text.."}")()

  elseif Option.Devices == "file" then
    axes = Option.FileDevices or {}
  end

  for i, A in ipairs(axes) do
    if type(A) == "number" then
      axes[i] = { Address = A, ID = "A", Name = string.format("A%i", A) }
    end
  end

  stat = {
    axis  = {};  -- axis names
    total = { caption = "Commands" };  -- number of pings
    pass  = { caption = "Passed"   };  -- passed counters
    fail  = { caption = "Failed"   };  -- failed counters
  --[err] = {};  -- error counters (created dynamically)
  }

  for i, A in ipairs(axes) do
    stat.axis[i] = string.format("%s%i", A.ID, A.Address)
    stat.pass[i] = 0
    stat.fail[i] = 0
    stat.total[i] = 0
  end
end


-- Test function
local cmds = {
  ["5342-0101"] = {
    SIG = "SmartDRIVE 1.2  ",
    { M.ATB.CMD_PING, "*" },
    { M.ATB.CMD_IOUPDATE, 0x00FFFFFF },
    { M.ATB.CMD_WRITE, M.ATB.VAR_RL0, "*" },
    { M.ATB.CMD_READ, M.ATB.VAR_RL0 },
    { M.ATB.CMD_SET, M.ATB.PAR_Signature + 65536 * 1234},
    { M.ATB.CMD_GET, M.ATB.PAR_Signature },
    --{ M.ATB.CMD_TRJSTART, "*300" },
    { M.ATB.CMD_TRJSTOP, "+1000" },
    { M.ATB.CMD_TRJGOTO, "*3200", "+300", "+1000" },
    --{ M.ATB.CMD_SEQEXE },
    --{ M.ATB.CMD_SEQADD },
  },
  ["5343-1030"] = {
    SIG = "SmartDRIVE 1.3.0",
    { M.ATB.CMD_PING, "*" },
    { M.ATB.CMD_IOUPDATE, 0x00FFFFFF },
    { M.ATB.CMD_WRITE, M.ATB.VAR_RL0, "*" },
    { M.ATB.CMD_READ, M.ATB.VAR_RL0 },
    { M.ATB.CMD_GET, M.ATB.PAR_Signature },
    { M.ATB.CMD_TRJSTOP, "+1000" },
    { M.ATB.CMD_TRJGOTO, "*3200", "+300", "+1000" },
  },
  ["5343-1040"] = {
    SIG = "SmartDRIVE 1.3.1",
    { M.ATB.CMD_PING, "*" },
    { M.ATB.CMD_IOUPDATE, 0x00FFFFFF },
    { M.ATB.CMD_WRITE, M.ATB.VAR_RL0, "*" },
    { M.ATB.CMD_READ, M.ATB.VAR_RL0 },
    { M.ATB.CMD_GET, M.ATB.PAR_Signature },
  },
}
local cmdn = {}
for k, v in pairs(M.ATB) do if k:match("^CMD_%w+$") then cmdn[v] = k end end

local function get_id(A)
  return string.format("%04X-%04X", M:Command(A.Address, M.ATB.CMD_GET, M.ATB.PAR_PID).MSW,
                                    M:Command(A.Address, M.ATB.CMD_GET, M.ATB.PAR_CID).MSW)
end


local function bus_test(i, A)
  local ok, err, cmdd
  
  if not A.id then
    cmdd = "GET_ID"
    ok, err = pcall(get_id, A)
    if ok then
      A.id = err
      print(A.Name, cmds[A.id].SIG, A.id)
    end
  end
  
  if A.id then
    local t, m, r
    local cmd = clone(cmds[A.id][math.random(#cmds[A.id])])
    for j = 2, #cmd do
      t = type(cmd[j])
      if t == "function" then cmd[j] = cmd[j]()
      elseif t == "string" then
        m, r = cmd[j]:match("([%*%+])(%d*)")
        if #r == 0 then r = 2^30 - 1 else r = tonumber(r) end
        if     m == "*" then cmd[j] = math.random(0, 2 * r) - r
        elseif m == "+" then cmd[j] = math.random(0, r) end
      end
    end
    cmdd = cmdn[cmd[1]]
    ok, err = pcall(M.Command, M, A.Address, unpack(cmd))
  end

  --if not ok then print(A.Name, cmdd, err) end
  assert(ok, err)
end


-- Send commands and collect data
local function update_stat()
  local rsp, err
  for i, A in ipairs(axes) do
    stat.total[i] = stat.total[i] + 1

    rsp, err, msg = pcall(bus_test, i, A)
    if rsp then
      -- Count the good response
      stat.pass[i] = stat.pass[i] + 1
    else
      -- Count the current error
      msg = err:match("^.*:%s+.-:%s+(.+)$")
      if not msg or msg:match(".-ATB.%d: $") then
        App:Log(string.format("%s: %s", A.Name, err), "error")
        msg = "Unexpected error"
      end
      stat.fail[i] = stat.fail[i] + 1
      stat[msg] = stat[msg] or { caption = msg }
      stat[msg][i] = (stat[msg][i] or 0) + 1
    end
  end
  return stat.total[1] or 0
end


-- Draw an individual panel
local function draw_curve(cr, w, h, curve)
  local total = stat.total[1] or 0
  local N = #stat.axis
  local dx = w / N
  local y = {}

  local te = cairo.TextExtents()
  local fe = cairo.FontExtents()
  cr:font_extents(fe)
  cr:save()

  -- Draw the caption
  local txt = curve.caption
  cr:save()
  cr:select_font_face(GUI.LabelFont, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_BOLD)
  cr:text_extents(txt, te)
  cr:set_source_rgb(0, 0, 0)
  cr:move_to((w-te.width)/2, h + 2 + fe.descent)
  cr:scale(1, -1)
  cr:show_text(txt)
  cr:restore()

  -- Draw the background and the outline
  local bcolor = GUI:OutlineColor("normal"):clone()
  local fcolor = GUI:BackgroundColor("normal"):clone():lighter(0.03)
  local D = 4
  local dh = h / D
  for i = 1, D do
    cr:set_source_rgb(fcolor:rgb())
    cr:rectangle(0, (i-1)*dh, w, dh)
    cr:fill()
    fcolor:darker(0.05)
  end
  cr:rectangle(0, 0, w, h)
  cr:set_source_rgb(0, 0, 0)
--cr:set_source_rgb(bcolor:rgb())
  cr:stroke()

  -- Draw the labels on the vertical axis
  for i = 1, 0 do --D-1 do
    txt = string.format("%.0f%%", 100*i/D)
    cr:text_extents(txt, te)
    cr:move_to(-fe.descent - 2, i*dh - te.width / 2)
    cr:save()
    cr:scale(1, -1)
    cr:rotate(-math.pi/2)
    cr:show_text(txt)
    cr:restore()
  end

  -- Draw the labels on the horizontal axis
  cr:save()
  --cr:select_font_face(GUI.LabelFont, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_BOLD)
  cr:set_source_rgb(0, 0, 0)
  for i = 1, N do
    y[i] = stat.total[i] == 0 and 0 or (h * (curve[i] or 0) / total)
    txt = stat.axis[i]
    cr:text_extents(txt, te)
    cr:move_to((i-1)*dx + (dx-te.width)/2, -fe.ascent)
    cr:scale(1, -1)
    cr:show_text(txt)
    cr:scale(1, -1)
  end
  cr:restore()

  -- Draw the vertical grid
  for i = 1, N-1 do
    cr:move_to(i*dx, 0)
    cr:line_to(i*dx, h)
  end
  cr:set_dash({ 1, 2 }, 2, 1)
  cr:set_source_rgb(0.3, 0.3, 0)
  cr:stroke()
  cr:set_dash({}, 0, 0)

  -- Draw the data bars
  cr:move_to(w, 0)
  cr:line_to(0, 0)
  for i = 1, N do
    cr:line_to((i-1)*dx, y[i])
    cr:line_to(i*dx, y[i])
    cr:line_to(i*dx, 0)
  end
  cr:line_to(w, 0)
  local dcolor = curve.caption == "Passed" and color(0.2, 0.7, 0.2) or color(1,0.35,0.3)
  cr:set_source_rgb(dcolor:rgb())
  cr:fill_preserve()
  cr:set_source_rgb(0, 0, 0)
--cr:set_source_rgb(dcolor:darker(0.2):rgb())
  cr:stroke()

  -- Draw the data counters
  cr:set_source_rgb(0, 0, 0)
  for i = 1, N do
    txt = tostring(curve[i] or 0)
    cr:text_extents(txt, te)
    cr:move_to((i-1)*dx + (dx-te.width)/2, 2 + fe.descent)
    cr:scale(1, -1)
    cr:show_text(txt)
    cr:scale(1, -1)
  end

  -- Draw the horizontal grid
  for i = 1, D-1 do
    cr:move_to(0, i*dh)
    cr:line_to(w, i*dh)
  end
  cr:set_dash({ 1, 2 }, 2, 1)
  cr:set_source_rgb(0.3, 0.3, 0)
--cr:set_source_rgb(bcolor:rgb())
  cr:stroke()
  cr:restore()
end


-- Draw the collected data in several panels
local function draw_stat(cr, w, h)
  try
  
  if #stat.axis == 0 then return end
  local draw = cairo.surface_get_type(cr:get_target()) == cairo.SURFACE_TYPE_IMAGE
  local TOP, BOTTOM, LEFT, RIGHT
  if draw then
    TOP, BOTTOM, LEFT, RIGHT = 40, 15, 0, 0
  else -- pdf
    TOP, BOTTOM, LEFT, RIGHT = 60, 40, 40, 40
  end

  cr:select_font_face(GUI.LabelFont, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_NORMAL)
  cr:set_font_size(GUI.LabelFontSize)
  cr:set_line_width(1)
  cr:set_antialias(cairo.ANTIALIAS_NONE)

  if draw then -- no background when saving a PDF
    cr:set_source_rgb(1, 1, 1)
    cr:paint()
  end
  cr:set_source_rgb(0, 0, 0)

  local n = 1
  local curves = {}
  for err, curve in pairs(stat) do
    if err:find(" ") then -- skip axis, total, pass and fail fields (error messages have at least 2 words)
      n = n + 1
      table.insert(curves, curve)
    end
  end
  table.insert(curves, stat.pass)

  local dh = math.floor((h - BOTTOM) / n)
  cr:save()
  cr:translate(LEFT+1, h - BOTTOM + dh)
  cr:scale(1, -1)
  for i = 1, n do
    cr:translate(0, dh);
    draw_curve(cr, w - LEFT - RIGHT - 1, dh - TOP, curves[i])
  end
  cr:restore()

  -- Draw the global informations
  local te = cairo.TextExtents()
  local fe = cairo.FontExtents()
  cr:font_extents(fe)
  local y = TOP + fe.ascent - fe.height - 2 -- aligned with the first title
  y = y - 1.5*fe.height

  local total = stat.total[1] or 0
  local txt = string.format("%i test cycle%s on %s @ %i Baud", total, total == 1 and "" or "s", App.Port, M.BusSpeed)
  if not draw then txt = string.format("%s with a timeout of %i ms", txt, M.BusTimeout) end
  cr:text_extents(txt, te)
  cr:move_to(LEFT, y)
  cr:show_text(txt)

  if draw then txt = Plot.Meta.RightNote or ""
  else         txt = os.date("%Y-%m-%d %H-%M-%S") end
  local te = cairo.TextExtents()
  cr:text_extents(txt, te)
  cr:move_to(w - RIGHT - te.width, y)
  cr:show_text(txt)

  catch err do
    log_error("ERROR", err)
    print(err.."\n"..debug.traceback())
    App.Status = err
  end
end


-- Save a PDF report with the collected data
local function save_stat(auto)
  if not win.fs.DirectoryExists(".reports") then win.fs.CreateDirectory(".reports") end
  local filename = path.join(".reports",
                             string.format("%s-%i_%s.pdf", App.Port, M.BusSpeed,
                             auto and os.date("%Y-%m-%d (auto)") or os.date("%Y-%m-%d %H-%M-%S")))
--local w, h = math.floor(297*72/25.4), math.floor(210*72/25.4) -- A4 landscape
  local w, h = math.floor(210*72/25.4), math.floor(297*72/25.4) -- A4 portrait
  local cs = cairo.pdf_surface_create(filename, w, h)
  local cr = cairo.ContextFromLUD(cairo.create(cs), true)
  draw_stat(cr, w, h)
  cr:destroy()
  cairo.surface_destroy(cs)
  if not auto then App:Log("Report saved to "..filename) end
end



--------------------------------------------------------------------------------------
local function button_click()
  App:Play("sndSelect")
end

local function set_devlist(self)
  if self then
    local devices = self:Tag("value")
    if devices == "file" then
      local file, sel, en, id
      if Option.Devices == "file" or not Option.FileDevices or #Option.FileDevices == 0 then
        file = App:PickFile({"INI Files (*.ini)", "All files (*.*)"}, false)
      end
      if file then
        sel = {}
        for a = 1, 31 do
          id = win.ini.ReadString(file, "Machine."..a, "ID")
          if #id ~= 0 then
            en = 0 == win.ini.ReadInteger(file, "Machine."..a, "Disabled")
            if en then
              print(id, a)
              table.insert(sel, { Address = a, ID = id, Name = string.format("%s%i", id, a) })
            end
          end
        end
        Option.FileDevices = sel
      end
    end
    if devices then Option.Devices = devices end
  end

  for i, ctl in ipairs(GUI:Find("devices").Controls) do
    ctl:Property("down", Option.Devices == ctl:Tag("value"))
  end
  reset_stat()
end

local function apply_baudrate()
  for i, ctl in ipairs(GUI:Find("bus-speed").Controls) do
    ctl:Property("down", App:Connected() and M.BusSpeed == ctl:Tag("baud"))
  end
  --GUI:Find("stop"):Enabled(App:Connected())
end

local function set_baudrate(self)
  local baudrate = self:Tag("baud")
  if App:NotConnected() or M.BusSpeed ~= baudrate then
    button_click()
    Option.BusSpeed = baudrate
    App:Connect()
  elseif App:Connected() then
    button_click()
    App:Disconnect()
  end
  apply_baudrate()
end

for i, ctl in ipairs(GUI:Find("bus-speed").Controls) do
  local baudrate = ctl:Tag("baud")
  if baudrate then
    ctl.OnClick = set_baudrate
    ctl:Style{allow_none = true, border = false}
    ctl:Caption(string.format("%i Baud", baudrate))
  end
end

for i, ctl in ipairs(GUI:Find("devices").Controls) do
  local value = ctl:Tag("value")
  if value then
    ctl.OnClick = set_devlist
  end
end

GUI:Find("save").OnClick = function(self)
  button_click()
  save_stat()
end

GUI:Find("auto-save").OnClick = function(self)
  button_click()
  Option.AutoSave = self:Down()
end

GUI:Find("stop").OnClick = function(self)
  button_click()
  App:Disconnect()
  apply_baudrate()
end

GUI:Find("plot").OnDraw = function(self, cr, w, h)
  try
    draw_stat(cr, w, h)
  catch err do
    self.OnTimer = nil
    print(err)
  end
  return true -- skip default drawing
end


--------------------------------------------------------------------------------------
local PAUSE
App.ReadPeriod = MAV(10)   -- averaged period of a measure cycle


function App:Command(cmd)
  return win.wm.SendMessage(self.Handle, Rem.CMD, Rem[cmd], 0)
end


function App:OnPreStart()
  M.BusSpeed   = Option.BusSpeed
  M.BusTimeout = Option.BusTimeout
  M.BusRetries = 0
end


function App:OnStart()
  apply_baudrate()
end


function App:OnStop()
  apply_baudrate()
end


function App:Connected() return M.IsReady end
function App:NotConnected() return not App:Connected() end


function App:Connect()
  self:Disconnect()
  reset_stat()
  cls()
  App:LogClear()
  App:Command("START")
  if App:NotConnected() then error("Cannot connect the machine to " .. App.Port) end
end


function App:Disconnect()
  if App:NotConnected() then return end
  App:Command("STOP")
  if App:Connected() then error("Cannot disconnect the machine from " .. App.Port) end
end


function App:OnTimer(i, dt)
  try
    if App:NotConnected() then
      Plot.Meta.RightNote = "Stopped"
    elseif PAUSE then
      Plot.Meta.RightNote = "Paused"
    else
      local n = update_stat()
      self.ReadPeriod:Push(dt * 1000)
      Plot.Meta.RightNote = string.format("%.0f ms/cycle", self.ReadPeriod.Value)
      if Option.AutoSave then save_stat(true) end
    end
    Canvas:Refresh()
  catch err do
    self.OnTimer = nil
    print(err)
  end
end


cls()
--App:LogClear()
set_devlist()
apply_baudrate()
Canvas:Refresh()
App:Timer(Option.CycleTime / 1000)
App:Show "Canvas"

]==================================================];
Options ={
};

};

{ Name = "M2", Body =
[==================================================[

]==================================================];
Options ={
};

};

{ Name = "M3", Body =
[==================================================[

]==================================================];
Options ={
};

};

{ Name = "M4", Body =
[==================================================[

]==================================================];
Options ={
};

};

{ Name = "M5", Body =
[==================================================[

]==================================================];
Options ={
};

};

{ Name = "Decolog", Body =
[==================================================[
-- Decodes motor traces from Prelud Monitor

--------------------------------------------------------------------------------------
-- GUI definition

local SP0 = 5       -- tight spacing/padding
local SP1 = 8       -- normal spacing/padding
local SP2 = 12      -- loose spacing/padding
local SP3 = 16      -- very loose spacing/padding

GUI.LabelFont       = "Segoe UI";
GUI.LabelFontSize   = 12;
GUI:Init()
local ocol = GUI:OutlineColor("normal"):clone()


GUI.CurveSet = function(self, id, w, h, x, y, set)
  local name = string.format("%s\n%s", set.mot, set.source)
  local hint = string.format("%s from %s", set.mot, set.source)
  if self:Children() == 0 then self:Spacer(nil, "100%%") end
  return self:Radio(id or set.id, w or 100, h or "fill", x or nil, y or nil, name, hint):Tag("motor", set.id)
end


GUI:New()
  :Style{"sep", color = ocol}
  :Style{"nob", border = false}
  :VBox("root", "fill", "fill"):Style{padding = SP3, spacing = SP3}

GUI:Add("root")
  :HBox("toolbar", "fill", 40):Style{spacing = SP1}
    :Button("open-set", 100, "fill"):Caption("Open"):Hint("Open a Prelud Monitor log"):Parent()
    :Button("add-set",  100, "fill"):Caption("Add"):Hint("Add a Prelud Monitor log"):Parent()
    :HBox("curve-sets", "100%%", "fill"):Style{spacing = SP1}:Parent()
    :Parent()

  :Plot("PLT", "fill", "100%%")
    :Style {
      color = color("white");
      border = true;
      padding_top = -0;
      padding_bottom = -5;
    }
    :Parent()
GUI:End()


--------------------------------------------------------------------------------------
Plot:Init("center")
Plot:Axis(2, 100, "", "", "lc")
Plot:Grid(1, 10, 0.1, 1, "%.1f", "%.1f")
Plot:AddCurve("Pos",     { color("blue"):rgb() },         .5, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("Vel",     { color("crimson"):rgb() },      .5, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("TRIG",    { color("seagreen"):rgb() },     .2, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("INMO",    { color("coral"):rgb() },        .2, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("DONE",    { color("deepskyblue"):rgb() },  .2, 1.5, GRAPH_XY_SAMPLED)


local function button_click()
  App:Play("sndSelect")
end


local function read_data(fn, out)
  local out = out or {}
  local fh = assert(io.open(fn, "r"))
  local rec, ts0, ts, node, mot, key, sta, pos, vel, msg, ye, mo, da, ho, mi, sc, ms
  fn = path.chext(path.getfile(fn), "")
  for line in fh:lines() do
    rec = string.explode(line, ";")
    for k, v in ipairs(rec) do rec[k] = v:match('^"(.-)"$') or v end
    -- [1]=Timestamp, [2]=Level, [3]=Node, [4]=Node name, [5]=Message, [6]=Context
    if rec[2] == "DEBUG-APP" then
      ye, mo, da, ho, mi, sc, ms = rec[1]:match("^(%d+)%-(%d+)%-(%d+)%s(%d+):(%d+):(%d+)[%.%,](%d+)$") -- 2017-01-20 16:40:23.475445
      ts = App:Timestamp(tonumber(ye), tonumber(mo), tonumber(da), tonumber(ho), tonumber(mi), tonumber(sc)) * 1e-7 + tonumber(ms) * 1e-6
      --if next(out) == nil then ts0 = ts end
      node = rec[3]
      msg = rec[5]
      mot, sta, pos, vel, msg = msg:match("^([%w%s_]+):.-TAG:(%x+)%s+DAT:([%+%-%,%.%d]+)%s+VEL:([%+%-%,%.%d]+)%s+(.*)")
      --mot, sta, pos, vel, msg = msg:match("^([%w%s_]+):.-TAG:(%x+)%s+POS:([%+%-%,%.%d]+)%s+VEL:([%+%-%,%.%d]+)%s+(.*)")
      key = string.format("%s.N%s.%s", fn, node, mot)
      mot = string.format("N%s.%s", node, mot)
      sta = tonumber(sta, 16)
      pos = tonumber((string.gsub(pos, ",", ".")))
      vel = tonumber((string.gsub(vel, ",", ".")))
      --print(ts - ts0, mot, sta, pos, vel, msg)
      if not out[key] then
        out[key] = { source = fn, mot = mot, id = key, xmax = 0, ymax = 0 }
        table.insert(out, out[key])
      end
      rec = out[key]
      if not rec.ts0 then rec.ts0 = ts end
      table.insert(rec, { ts = ts-rec.ts0, pos = pos, vel = vel, sta = sta })
      if math.abs(pos) > rec.ymax then rec.ymax = math.abs(pos) end
      if math.abs(vel) > rec.ymax then rec.ymax = math.abs(vel) end
      rec.xmax = rec[#rec].ts
    end
  end
  fh:close()
  out.xmax, out.ymax = 0, 0
  for i, rec in ipairs(out) do
    if rec.xmax > out.xmax then out.xmax = rec.xmax end
    if rec.ymax > out.ymax then out.ymax = rec.ymax end
  end
  return out
end


local function select_motor(mot)
  print(mot)
  mot = mot or Plot.Data[1].id
  Plot.Motor = mot
  Plot:Title(mot)
  local dat = Plot.Data[mot]
  --print(mot)
  local len = #dat
  if len ~= 0 then
    --table.insert(dat, dat[len])   len = len + 1
    --table.insert(dat, 1, dat[1])  len = len + 1
  end
  if not dat.row then
    dat.raw = {}
    dat.raw.pos  = data.deque(len)
    dat.raw.vel  = data.deque(len)
    dat.raw.done = data.deque(len)
    dat.raw.inmo = data.deque(len)
    dat.raw.trig = data.deque(len)
    for i, rec in ipairs(dat) do
      --printf("  | T %9.6f | P%+12.6f | V%+12.6f | %04X |", rec.ts, rec.pos, rec.vel, rec.sta)
      dat.raw.pos :pushlast { x = rec.ts, y = rec.pos }
      dat.raw.vel :pushlast { x = rec.ts, y = rec.vel }
    end
    Plot:Axis(.1 * math.ceil(Plot.Data.xmax / .1), 2 * 20 * math.ceil(Plot.Data.ymax / 20), "", "", "lc")
    Plot:Grid(1, 10, 0.1, 1, "%.1f", "%.1f")
    local ylo = Plot.Meta.YALIGN == 0 and -Plot.Meta.YMAX/ 2 or 0
    local h   = Plot.Meta.YFINE
    for i, rec in ipairs(dat) do
      dat.raw.done:pushlast { x = rec.ts, y = ylo + 0.5*h + h * bit.bit(rec.sta, 0) }
      dat.raw.inmo:pushlast { x = rec.ts, y = ylo + 3.5*h + h * bit.bit(rec.sta, 8) }
      dat.raw.trig:pushlast { x = rec.ts, y = ylo + 2.0*h + h * bit.bit(rec.sta, 9) }
    end
  end
  Plot.Curves[Plot:Curve("Pos")]  = dat.raw.pos
  Plot.Curves[Plot:Curve("Vel")]  = dat.raw.vel
  Plot.Curves[Plot:Curve("DONE")] = dat.raw.done
  Plot.Curves[Plot:Curve("TRIG")] = dat.raw.trig
  Plot.Curves[Plot:Curve("INMO")] = dat.raw.inmo
end


GUI:Find("PLT").OnMenu = function(self)
  return {
    { Caption = "Save as...", Image = "imgSave",
      OnClick = function()
        local filename = App:PickFile({"PDF Files (*.pdf)", "SVG Files (*.svg)", "All files (*.*)"}, true, Plot.Motor, "pdf")
        Canvas:SaveAs(filename)
      end };
  }
end


local function CurveSet_Click(self)
  button_click()
  select_motor(self:Tag("motor"))
end


local function load_log(fresh)
  button_click()
  local fn = App:PickFile({"Log Files (*.csv)", "All files (*.*)"}, false)
  if not fn then return end
  if fresh then Plot.Data = read_data(fn)
  else          Plot.Data = read_data(fn, Plot.Data) end
  local sets = GUI:Find("curve-sets"):DeleteChildren()
  for i, set in ipairs(Plot.Data) do
    sets:CurveSet(nil, nil, nil, nil, nil, set).OnClick = CurveSet_Click
  end
  local n = sets:Children()
  if n > 1 then sets:Child(n):DoClick() end
end


GUI:Find("open-set").OnClick = function(self)
  button_click()
  load_log(true)
end


GUI:Find("add-set").OnClick = function(self)
  button_click()
  load_log(false)
end


--------------------------------------------------------------------------------------
function App:ResetData()
  local len = 100
  local i, c, m = Plot:Curve("DONE")
  self.RawData = data.deque(len)
  local dat = data.filter(model):spline("shemanarev"):flatten(len):data()
  for _, pt in ipairs(dat) do self.RawData:pushlast(pt) end
  Plot.Curves[i] = self.RawData
end


cls()
App:LogClear()
App:Show("Canvas")

]==================================================];
Options ={
};

};

{ Name = "M7", Body =
[==================================================[
-- ATB Tester
-- ----------------------------------------------------
-- Disable all axes
-- Set [Machine]/BusRetries to 0
-- Set [Machine]/BusTimeout to 20
-- Set [Machine]/BusSpeed to the correct baudrate

App:LogClear()

-- Table with axes to test or empty table to test them all
local axes = { Y }
if #axes == 0 then
  for i, A in ipairs(M.Axes) do axes[i] = A end
end


-- Table with collected data
local stat = {
  axis  = {};  -- axis names
  total = {};  -- number of pings
  pass  = {};  -- passed counters
  fail  = {};  -- failed counters
--[err] = {};  -- error counters (created dynamically)
}
for i, A in ipairs(axes) do
  stat.axis[i] = string.format("%s%i", A.ID, A.Address)
  stat.pass[i] = 0
  stat.fail[i] = 0
  stat.total[i] = 0
end


local function print_stat()
  cls()
  local COL1 = 31 -- width of the first column
  local COLN = 7  -- width of the other columns
  local N = #stat.axis

  -- Build and print the table header
  local row = { ("Description"):rpad(COL1) }
  local sep = { string.rep("-", COL1) }
  for i = 1, N do
    table.insert(row, stat.axis[i]:lpad(COLN))
    table.insert(sep, string.rep("-", COLN))
  end
  row = table.concat(row, " ")
  sep = table.concat(sep, " ")
  print(row)
  print(sep)

  -- Print statistics for each error type
  for err, count in pairs(stat) do
    if err:find(" ") then -- skip axis, total, pass and fail fields (error messages have at least 2 words)
      row = { err:sub(1, COL1):rpad(COL1) }
      for i = 1, N do
        table.insert(row, string.format("%i", count[i] or 0):lpad(COLN))
      end
      print(table.concat(row, " "))
    end
  end
  print(sep)

  -- Print summary
  local failed = { ("Failed"):rpad(COL1) }
  local passed = { ("Passed"):rpad(COL1) }
  local totals = { ("Tests") :rpad(COL1) }
  for i = 1, N do
    table.insert(failed, string.format("%.1f%%", 100 * stat.fail[i] / stat.total[i]):lpad(COLN))
    table.insert(passed, string.format("%.1f%%", 100 * stat.pass[i] / stat.total[i]):lpad(COLN))
    table.insert(totals, string.format("%i", stat.total[i]):lpad(COLN))
  end
  print(table.concat(totals, " "))
  print(table.concat(failed, " "))
  print(table.concat(passed, " "))
  print("\n")
end


if not M.IsReady then error("The machine is not started!") end

UI.Cancel = false
UI.CancelButton = false
UI.OnButtonStop = function() UI.Cancel = true end
UI:Set("P")

local pings = 0
local failed = 0
local rsp, err, dat
repeat
  dat = math.floor(2^32 * math.random())
  for i, A in ipairs(axes) do
    pings = pings + 1
    stat.total[i] = stat.total[i] + 1
    rsp, err = pcall(M.Command, M, A.Address, 1, dat) -- PING
    if rsp then
      -- Count the good response
      stat.pass[i] = stat.pass[i] + 1
    else
      -- Count the current error
      failed = failed + 1
      stat.fail[i] = stat.fail[i] + 1
      stat[err] = stat[err] or {}
      stat[err][i] = (stat[err][i] or 0) + 1
      App:Log(string.format("%s%i (%s): %s", A.ID, A.Address, A.Name, err), "error")
    end
  end
  print_stat()
  UI:Msg(string.format("Pings: #c[yellow]{%i}, Passed: #c[yellow]{%i}, Failed: #c[yellow]{%i}", pings, pings - failed, failed))
  UI:Process()
  --win.sys.Sleep(20)
until UI.Cancel

UI.OnButtonStop = nil
UI.CancelButton = true

]==================================================];
Options ={
};

};

{ Name = "M8", Body =
[==================================================[
-- ATB Tester (graphical)
-- ----------------------------------------------------
-- Disable all axes
-- Set [Machine]/BusRetries to 0
-- Set [Machine]/BusTimeout to 20
-- Set [Machine]/BusSpeed to the correct baudrate


App:LogClear()
App.ProcessEvent = nil
App.OnOptionChanged = nil
App.OnCycle = nil
App.OnTimer = nil
if not M.IsReady then error("The machine is not started!") end


-- Table with axes on test or empty table to test them all
local axes = { X, Y, Z, W, T }
if #axes == 0 then
  for i, A in ipairs(M.Axes) do
    axes[i] = A
    A.Disabled = true
  end
end


-- Table with collected data
local stat = {
  axis  = {};  -- axis names
  total = { caption = "Commands" };  -- number of pings
  pass  = { caption = "Passed"   };  -- passed counters
  fail  = { caption = "Failed"   };  -- failed counters
--[err] = {};  -- error counters (created dynamically)
}
for i, A in ipairs(axes) do
  stat.axis[i] = string.format("%s%i", A.ID, A.Address)
  stat.pass[i] = 0
  stat.fail[i] = 0
  stat.total[i] = 0
end

-- Print collected statistics
local function print_stat()
  cls()
  local COL1 = 31 -- width of the first column
  local COLN = 7  -- width of the other columns
  local N = #stat.axis

  -- Build and print the table header
  local row = { ("Description"):rpad(COL1) }
  local sep = { string.rep("-", COL1) }
  for i = 1, N do
    table.insert(row, stat.axis[i]:lpad(COLN))
    table.insert(sep, string.rep("-", COLN))
  end
  row = table.concat(row, " ")
  sep = table.concat(sep, " ")
  print(row)
  print(sep)

  -- Print statistics for each error type
  for err, count in pairs(stat) do
    if err:find(" ") then -- skip axis, total, pass and fail fields (error messages have at least 2 words)
      row = { err:sub(1, COL1):rpad(COL1) }
      for i = 1, N do
        table.insert(row, string.format("%i", count[i] or 0):lpad(COLN))
      end
      print(table.concat(row, " "))
    end
  end
  print(sep)

  -- Print summary
  local failed = { stat.fail.caption:rpad(COL1) }
  local passed = { stat.pass.caption:rpad(COL1) }
  local totals = { stat.total.caption:rpad(COL1) }
  for i = 1, N do
    table.insert(failed, string.format("%.1f%%", 100 * stat.fail[i] / stat.total[i]):lpad(COLN))
    table.insert(passed, string.format("%.1f%%", 100 * stat.pass[i] / stat.total[i]):lpad(COLN))
    table.insert(totals, string.format("%i", stat.total[i]):lpad(COLN))
  end
  print(table.concat(totals, " "))
  print(table.concat(failed, " "))
  print(table.concat(passed, " "))
  print("\n")
end


-- Drawing support
local cairo = require "lcairo"

function Canvas:Create()
  self:Destroy()
  local cs = cairo.image_surface_create_for_data(self.Data, cairo.FORMAT_ARGB32, self.Width, self.Height, self.Stride)
  local cr = cairo.create(cs)
  self.Surface = cairo.SurfaceFromLUD(cs, true)
  self.Context = cairo.ContextFromLUD(cr, true)
  self:Clear("white")
end

function Canvas:Destroy()
  if self.Surface then self.Surface:destroy() self.Surface = nil end
  if self.Context then self.Context:destroy() self.Context = nil end
  self:Clear("white")
end

local function draw_curve(cr, w, h, curve)
  local total = stat.total[1] or 0
  local N = #stat.axis
  local dx = w / N
  local y = {}

  local te = cairo.TextExtents()
  local fe = cairo.FontExtents()
  cr:font_extents(fe)
  cr:save()

  -- Draw the caption
  local txt = curve.caption
  cr:text_extents(txt, te)
  cr:set_source_rgb(0, 0, 0)
  cr:save()
  cr:move_to((w-te.width)/2, h + 2 + fe.descent)
  cr:scale(1, -1)
  cr:show_text(txt)
  cr:restore()

  -- Draw the background and the outline
  local D = 4
  local dh = h / D
  for i = 1, D do
    cr:set_source_rgb(1-i/32, 1-i/32, 1-i/32)
    cr:rectangle(0, (i-1)*dh, w, dh)
    cr:fill()
  end
  cr:rectangle(0, 0, w, h)
  cr:set_source_rgb(0, 0, 0)
  cr:stroke()

  -- Draw the labels on the vertical axis
  for i = 1, 0 do --D-1 do
    txt = string.format("%.0f%%", 100*i/D)
    cr:text_extents(txt, te)
    cr:move_to(-fe.descent - 2, i*dh - te.width / 2)
    cr:save()
    cr:scale(1, -1)
    cr:rotate(-math.pi/2)
    cr:show_text(txt)
    cr:restore()
  end

  -- Draw the labels on the horizontal axis
  cr:set_source_rgb(0, 0, 0)
  for i = 1, N do
    y[i] = stat.total[i] == 0 and 0 or (h * (curve[i] or 0) / total)
    txt = stat.axis[i]
    cr:text_extents(txt, te)
    cr:move_to((i-1)*dx + (dx-te.width)/2, -fe.height)
    cr:scale(1, -1)
    cr:show_text(txt)
    cr:scale(1, -1)
    txt = tostring(curve[i] or 0)
    cr:text_extents(txt, te)
    cr:move_to((i-1)*dx + (dx-te.width)/2, 2 + fe.descent)
    cr:scale(1, -1)
    cr:show_text(txt)
    cr:scale(1, -1)
  end

  -- Draw the data bars
  cr:move_to(w, 0)
  cr:line_to(0, 0)
  for i = 1, N do
    cr:line_to((i-1)*dx, y[i])
    cr:line_to(i*dx, y[i])
    cr:line_to(i*dx, 0)
  end
  cr:line_to(w, 0)
  if curve.caption == "Passed" then
    cr:set_source_rgb(0.2, 0.7, 0.2)
  else
    cr:set_source_rgb(1,0.35,0.3)
  end
  cr:fill_preserve()
  cr:set_source_rgb(0, 0, 0)
  cr:stroke()

  -- Draw the grid
  for i = 1, D-1 do
    cr:move_to(0, i*dh)
    cr:line_to(w, i*dh)
  end
  cr:set_dash({ 1, 2 }, 2, 1)
  cr:set_source_rgb(0.3, 0.3, 0.)
  cr:stroke()
  cr:restore()
end

local function draw_stat(cr, w, h)
  if #stat.axis == 0 then return end
  local cr  = cr or Canvas.Context
  local w   = w  or Canvas.Width
  local h   = h  or Canvas.Height
  local TOP, BOTTOM, LEFT, RIGHT = 60, 40, 40, 40

  local draw = cairo.surface_get_type(cr:get_target()) == cairo.SURFACE_TYPE_IMAGE
  cr:select_font_face("Segoe UI", cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_NORMAL)
  cr:set_font_size(12)
  cr:set_line_width(1)
  cr:set_antialias(cairo.ANTIALIAS_NONE)

  if draw then -- no background when saving a PDF
    cr:set_source_rgb(1, 1, 1)
    cr:paint()
  end
  cr:set_source_rgb(0, 0, 0)

  local n = 1
  local curves = {}
  for err, curve in pairs(stat) do
    if err:find(" ") then -- skip axis, total, pass and fail fields (error messages have at least 2 words)
      n = n + 1
      table.insert(curves, curve)
    end
  end
  table.insert(curves, stat.pass)

  local dh = math.floor((h - BOTTOM) / n)
  cr:save()
  cr:translate(LEFT+1, h - BOTTOM + dh)
  cr:scale(1, -1)
  for i = 1, n do
    cr:translate(0, dh);
    draw_curve(cr, w - LEFT - RIGHT - 1, dh - TOP, curves[i])
  end
  cr:restore()

  local total = stat.total[1] or 0
  local txt = string.format("%i command%s/axis on %s", total, total == 1 and "" or "s", App.Port)
  local te = cairo.TextExtents()
  local fe = cairo.FontExtents()
  cr:font_extents(fe)
  cr:text_extents(txt, te)
  cr:move_to(LEFT, BOTTOM - te.height)
  cr:show_text(txt)

  if not draw then
    txt = os.date("%Y-%m-%d %H-%M-%S")
    local te = cairo.TextExtents()
    cr:text_extents(txt, te)
    cr:move_to(w - RIGHT - te.width, BOTTOM - te.height)
    cr:show_text(txt)
  end

  Canvas:Update()
end

local function save_stat()
  local filename = os.date("%Y-%m-%d") .. ".pdf"
--local w, h = math.floor(297*72/25.4), math.floor(210*72/25.4) -- A4 landscape
  local w, h = math.floor(210*72/25.4), math.floor(297*72/25.4) -- A4 portrait
  local cs = cairo.pdf_surface_create(filename, w, h)
  local cr = cairo.ContextFromLUD(cairo.create(cs), true)
  draw_stat(cr, w, h)
  cr:destroy()
  cairo.surface_destroy(cs)
end


-- Prepare the drawing zone
Canvas:Create()
App:Show("Canvas")


UI.Cancel = false
UI.CancelButton = false
UI.OnButtonStop = function() UI.Cancel = true end
UI:Set("P")

local pings = 0
local failed = 0
local rsp, err, dat
repeat
  dat = math.floor(2^32 * math.random())
  for i, A in ipairs(axes) do
    pings = pings + 1
    stat.total[i] = stat.total[i] + 1
    rsp, err = pcall(M.Command, M, A.Address, 0x01, dat)
    if rsp then
      -- Count the good response
      stat.pass[i] = stat.pass[i] + 1
    else
      -- Count the current error
      failed = failed + 1
      stat.fail[i] = stat.fail[i] + 1
      stat[err] = stat[err] or { caption = err }
      stat[err][i] = (stat[err][i] or 0) + 1
      --App:Log(string.format("%s%i (%s): %s", A.ID, A.Address, A.Name, err), "error")
    end
  end
  print_stat()
  draw_stat()
  save_stat()
  UI:Msg(string.format("Pings: #c[yellow]{%i}, Passed: #c[yellow]{%i}, Failed: #c[yellow]{%i}", pings, pings - failed, failed))
  UI:Process()
  --win.sys.Sleep(20)
until UI.Cancel

UI.OnButtonStop = nil
UI.CancelButton = true

]==================================================];
Options ={
};

};

{ Name = "Load", Body =
[==================================================[
-- Called after the application was loaded


--------------------------------------------------------------------------------
Rem = {
  CMD         = 0x400+102;  -- Remote Command (SendMessage or PostMessage)
  -- Remote commands
  START       = 1000;       -- Starts the machine.
  STOP        = 1001;       -- Stops the machine.
  EMSTOP      = 1002;       -- Stops the machine without parking.
  MACRO       = 1010;       -- Runs a macro. The Data argument is a string with the macro name.
  CANCEL      = 1011;       -- Cancel the execution of a macro.
  EXIT        = 1020;       -- Stops the machine and closes the application.
  STATUS      = 1021;       -- Return the applications status flags.
  EVAL        = 1022;       -- Executes a Lua chunk on the Console. The Data argument is a string with a Lua chunk.
  GETERROR    = 1023;       -- Requests the current error
  -- STATUS flags
  LOADED      = 0;          -- The application was loaded and is ready for user interaction.
  STARTED     = 1;          -- The machine was successfully started.
  BUSY        = 2;          -- The application is actively doing some work. The UI window is displayed.
  ERROR       = 3;          -- The error message window is displayed. The window can be closed by the CMD_GETERROR command.
}
-- execute a command without data
-- rc = win.wm.SendData(hWnd, CMD_STATUS) -- read the status flags
-- local started = bit.band(rc, STARTED) ~= 0  -- true if the machine is started
-- local busy = bit.band(rc, BUSY) ~= 0  -- true if a macro is already running
-- if started and not busy then -- the macro can be run
-- execute a command with data
-- rc = win.wm.SendData(hWnd, CMD_MACRO, "M8") -- run a macro


--------------------------------------------------------------------------------
local function log(fmt, ...)
  fmt = tostring(fmt or "")
  if #fmt == 0 then print("\n") else --printf(os.date("%Y-%m-%d %H-%M-%S") .. " | " .. fmt:match("%s*(.*)"), ...) end
    fmt = string.format(fmt:match("%s*(.*)") .. "\n", ...)
    local first = true
    for l in fmt:gmatch("([^\n]-)\n") do
      print((first and os.date("%Y-%m-%d %H-%M-%S") or string.rep(" ", 19)) .. " | " .. l)
      first = false
    end
  end
end

debug._LEVEL = { DEBUG = 1, INFO  = 2, WARN  = 3, ERROR = 4 }
function debug.set_debug_level()
  if     App.Option[5] then _DEBUG = debug._LEVEL.DEBUG
  elseif App.Option[6] then _DEBUG = debug._LEVEL.INFO
  elseif App.Option[7] then _DEBUG = debug._LEVEL.WARN
  elseif App.Option[8] then _DEBUG = debug._LEVEL.ERROR end
end

function log_dbg(fmt, ...)   if _DEBUG and _DEBUG <= debug._LEVEL.DEBUG  then log(fmt, ...) end end
function log_info(fmt, ...)  if _DEBUG and _DEBUG <= debug._LEVEL.INFO   then log(fmt, ...) end end
function log_warn(fmt, ...)  if _DEBUG and _DEBUG <= debug._LEVEL.WARN   then log(fmt, ...) end end
function log_error(fmt, ...) if _DEBUG and _DEBUG <= debug._LEVEL.ERROR  then log(fmt, ...) App:Play "sndFailed" end end

function dbg() return _DEBUG == debug._LEVEL.DEBUG end

function debug.halt(msg, to)
  to = to or 0
  debug.halt_counter = debug.halt_counter or 1
  local id = "Breakpoint " .. debug.halt_counter
  debug.halt_counter = debug.halt_counter + 1
  local old_setup = UI.Buttons
  local old_text = UI.Text
  local old_title = UI.Title
  UI.Title = "Breakpoint"
  if msg then
    log_dbg(id .. ": " .. msg)
    UI:Wait(to, "S", "#s[9]{" .. id .. "}#p" .. msg)
  else
    log_dbg(id)
    UI:Wait(to, "S", id)
  end
  UI.Title = old_title
  UI:Msg(old_setup, old_text)
end


function dbg() return _DEBUG == debug._LEVEL.DEBUG end


function dbg_halt(msg, to)
  if _DEBUG == debug._LEVEL.DEBUG then debug.halt(msg, to) end
end


--function OnMacroError() log_error("\n%s", __TRACEBACK) App:Show("Console") end
function OnMacroError() print(__TRACEBACK) App:Show("Console") end


--------------------------------------------------------------------------------
bit.fromU16 = function(vint) return bit.lsw(vint) end
bit.fromS16 = function(vint) return bit.sxt(vint, 15) end
bit.fromU32 = function(vint) return bit.cast(vint) end
bit.fromS32 = function(vint) return bit.sxt(vint, 31) end
bit.fromQ   = function(q, vint) return bit.sxt(vint, 31) / bit.set(0, q) end
bit.fromFLT = function(vint)
  if vint == 0 then return 0 end
  return (1 - 2 * bit.bit(vint, 31)) * bit.set(bit.band(vint, 0x7FFFFF), 23) * 2^(bit.byte(vint, 23) - 150)
end

bit.toU16   = function(vflt) return bit.lsw(math.round(vflt)) end
bit.toS16   = function(vflt) return bit.sxt(math.round(vflt), 15) end
bit.toU32   = function(vflt) return math.round(vflt) end
bit.toS32   = function(vflt) return math.round(vflt) end
bit.toQ     = function(q, vflt) return math.round(vflt * bit.set(0, q)) end

-- conversion double -> format flotant DSP
bit.toFP = function(vflt)
  local exp = 0
  if vflt ~= 0 then
    if vflt > 0 then
      if vflt >= 1 then  while vflt >= 1    do vflt = 0.5 * vflt; exp = exp + 1 end
      else               while vflt < 0.5   do vflt = 2.0 * vflt; exp = exp - 1 end  end
    else
      if vflt < -1 then  while vflt < -1    do vflt = 0.5 * vflt; exp = exp + 1 end
      else               while vflt >= -0.5 do vflt = 2.0 * vflt; exp = exp - 1 end  end
    end
  end
  vflt = math.round(vflt * 2^31)
  if vflt >= 2^31 then vflt = 0.5 * vflt exp = exp + 1 end
  return vflt, exp
end

bit.toFLT   = function(vflt)
  if vflt == 0 then return 0 end
  local s = vflt < 0 and 2^31 or 0
  vflt = math.abs(vflt)
  local e = 0
  local f, m = vflt, vflt * 2^23
  --printf("s = %i, e = %3i, lzc = %2i, m = 0x%08X / %s / %.6f", bit.bit(s, 31), e, bit.lzc(m), m, bit.tobin(m, 32), f)
  while f < 1 or f >= 2 do
    e = e + (f < 1 and -1 or 1)
    f = vflt * 2^-e
    m = f * 2^23
    --printf("s = %i, e = %3i, lzc = %2i, m = 0x%08X / %s / %.6f", bit.bit(s, 31), e, bit.lzc(m), m, bit.tobin(m, 32), f)
  end
  return s + bit.lshift(e + 0x7E, 23) + bit.clr(m, 24)
end

bit.toFLC   = function(vflt)
  vflt = bit.toFLT(vflt)
  if vflt < 0x80000000 then return vflt else return 0x80000000 - vflt end
end


--------------------------------------------------------------------------------
function UI:Query(prompt, setup)
  local old_setup = UI.Buttons
  local old_text = UI.Text
  local old_title = UI.Title
  setup = setup or "SP"
  UI.Title = "Input"
  prompt = prompt and string.format("#s[9]%s#S#p#c[yellow]#q{}#n#h{|}", prompt) or string.format("#c[yellow]#q{}#n#h{|}", prompt)
  local btn = UI:Wait(0, setup, prompt)
  UI.Title = old_title
  UI:Msg(old_setup, old_text)
  if btn == "S" or btn == "K" then return tonumber(UI.Input), UI.Input end
end

function UI:MsgEx(msg, ...) log_info(msg, ...) self:Msg(msg) end
function UI:WaitEx(to, btn, msg, ...) log_info(msg, ...) self:Wait(to, btn, msg) end


--------------------------------------------------------------------------------
function os.run(cmd, ...)
  local rc = os.execute(string.format(cmd, ...) .. ">temp.txt")
  local rs = ""
  local f = io.open("temp.txt")
  if f then
    rs = assert(f:read('*a')):trim()
    --rs = string.gsub(rs, '[\n\r]+', ' | ')
    f:close()
  end
  return rs
end


--------------------------------------------------------------------------------
App:Show("Macros")
App:Macro("Main")
dofileex("SDRV.lua")

]==================================================];
Options ={
};

};

{ Name = "Decolog_copy", Body =
[==================================================[
-- Decodes motor traces from Prelud Monitor or from atb11.dll with DebugView

--------------------------------------------------------------------------------------
-- GUI definition

local SP0 = 5       -- tight spacing/padding
local SP1 = 8       -- normal spacing/padding
local SP2 = 12      -- loose spacing/padding
local SP3 = 16      -- very loose spacing/padding

GUI.LabelFont       = "Segoe UI";
GUI.LabelFontSize   = 12;
GUI:Init()
local ocol = GUI:OutlineColor("normal"):clone()


GUI.CurveSet = function(self, id, w, h, x, y, set)
  local name = string.format("%s\n%s", set.mot, set.source)
  local hint = string.format("%s from %s", set.mot, set.source)
  if self:Children() == 0 then self:Spacer(nil, "100%%") end
  return self:Radio(id or set.id, w or 100, h or "fill", x or nil, y or nil, name, hint):Tag("motor", set.id)
end


GUI:New()
  :Style{"sep", color = ocol}
  :Style{"nob", border = false}
  :VBox("root", "fill", "fill"):Style{padding = SP3, spacing = SP3}

GUI:Add("root")
  :HBox("toolbar", "fill", 40):Style{spacing = SP1}
    :Button("open-set", 100, "fill"):Caption("Open"):Hint("Open a Prelud Monitor log"):Parent()
    :Button("add-set",  100, "fill"):Caption("Add"):Hint("Add a Prelud Monitor log"):Parent()
    :HBox("curve-sets", "100%%", "fill"):Style{spacing = SP1}:Parent()
    :Parent()

  :Plot("PLT", "fill", "100%%")
    :Style {
      color = color("white");
      border = true;
      padding_top = -0;
      padding_bottom = -5;
    }
    :Parent()
GUI:End()


--------------------------------------------------------------------------------------
Plot:Init("center")
Plot:Axis(2, 100, "", "", "lc")
Plot:Grid(1, 10, 0.1, 1, "%.1f", "%.1f")
Plot:AddCurve("Pos",     { color("blue"):rgb() },         .5, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("Vel",     { color("crimson"):rgb() },      .5, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("TRIG",    { color("seagreen"):rgb() },     .2, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("INMO",    { color("coral"):rgb() },        .2, 1.5, GRAPH_XY_SAMPLED)
Plot:AddCurve("DONE",    { color("deepskyblue"):rgb() },  .2, 1.5, GRAPH_XY_SAMPLED)


local function button_click()
  App:Play("sndSelect")
end


local cmd = {
  [0x00] = "RESET";
  [0x01] = "PING";
  [0x04] = "MODE";
  [0x05] = "IOUPDATE";
  [0x0E] = "WRITE";
  [0x0F] = "READ";
  [0x11] = "SET";
  [0x12] = "GET";
  [0x13] = "SAVE";
  [0x14] = "LOAD";
  [0x20] = "TRJINIT";
  [0x21] = "START";
  [0x22] = "STOP";
  [0x23] = "GOTO";
  [0x24] = "STEP";
}

local mode = {
  [0]  = "OFF";
  [1]  = "CUSTOM";
  [3]  = "REMOTE";
  [4]  = "POSITION";
  [5]  = "VELOCITY";
  [6]  = "VELOCITY_DIR";
  [7]  = "VELOCITY_STSP";
  [8]  = "VELOCITY_STSP_DIR";
  [9]  = "ADVANCE";
  [10] = "ADVANCE_DIR";
  [11] = "PUSH_PULL_NOSW";
  [12] = "PUSH_PULL_HOMESW";
  [31] = "IDLE";
}

local function read_data(fn, out)
  local out = out or {}
  local fh = assert(io.open(fn, "r"))
  local rec, ts0, ts, dt, node, mot, key, sta, pos, vel, msg, ye, mo, da, ho, mi, sc, ms
  local typ = path.getext(fn)
  fn = path.chext(path.getfile(fn), "")
  if typ == "csv" then
    for line in fh:lines() do
      rec = string.explode(line, ";")
      for k, v in ipairs(rec) do rec[k] = v:match('^"(.-)"$') or v end
      -- [1]=Timestamp, [2]=Level, [3]=Node, [4]=Node name, [5]=Message, [6]=Context
      if rec[2] == "DEBUG-APP" then
        ye, mo, da, ho, mi, sc, ms = rec[1]:match("^(%d+)%-(%d+)%-(%d+)%s(%d+):(%d+):(%d+)[%.%,](%d+)$") -- 2017-01-20 16:40:23.475445
        ts = App:Timestamp(tonumber(ye), tonumber(mo), tonumber(da), tonumber(ho), tonumber(mi), tonumber(sc)) * 1e-7 + tonumber(ms) * 1e-6
        --if next(out) == nil then ts0 = ts end
        node = rec[3]
        msg = rec[5]
        mot, sta, pos, vel, msg = msg:match("^([%w%s_]+):.-TAG:(%x+)%s+DAT:([%+%-%,%.%d]+)%s+VEL:([%+%-%,%.%d]+)%s+(.*)")
        --mot, sta, pos, vel, msg = msg:match("^([%w%s_]+):.-TAG:(%x+)%s+POS:([%+%-%,%.%d]+)%s+VEL:([%+%-%,%.%d]+)%s+(.*)")
        key = string.format("%s.N%s.%s", fn, node, mot)
        mot = string.format("N%s.%s", node, mot)
        sta = tonumber(sta, 16)
        pos = tonumber((string.gsub(pos, ",", ".")))
        vel = tonumber((string.gsub(vel, ",", ".")))
        --print(ts - ts0, mot, sta, pos, vel, msg)
        if not out[key] then
          out[key] = { source = fn, mot = mot, id = key, xmax = 0, ymax = 0 }
          table.insert(out, out[key])
        end
        rec = out[key]
        if not rec.ts0 then rec.ts0 = ts end
        table.insert(rec, { ts = ts-rec.ts0, pos = pos, vel = vel, sta = sta })
        if math.abs(pos) > rec.ymax then rec.ymax = math.abs(pos) end
        if math.abs(vel) > rec.ymax then rec.ymax = math.abs(vel) end
        rec.xmax = rec[#rec].ts
      end
    end
  elseif typ == "txt" then
    cls()
    print [[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">]]
    print [[<html xmlns="http://www.w3.org/1999/xhtml"><head>]]
    print [[<meta http-equiv="content-type" content="text/html; charset=utf-8">]]
    print [[</head><body><pre>]]
    print "\n"
    ye, mo, da = App:LocalTime()
    for line in fh:lines() do
      line = line:trim()
      if #line > 0 then
        --print(line)
        ho, mi, sc, ms, line = line:match("^%d+%s+(%d+):(%d+):(%d+)[%.%,](%d+)%s+%b[]%s+(.-)$")
        if line then
          ts = 60 * 60 * tonumber(ho) + 60 * tonumber(mi) + tonumber(sc) + tonumber(ms) / 1000
          if not ts0 then ts0 = ts end
          dt = ts - ts0
          if dt < 0 or dt > 10 then dt = 0; ts0 = nil print("...\n") end
          ts0 = ts
          rec = line:match("^ATB%s+|%s+(.-)$")
          if rec then
            rec = rec:explode(" ")
            if rec[1] == "TX:" then
              mot = string.format("M%02i", bit.band(tonumber(rec[2], 16), 0x001F))
              pos = tonumber(rec[4], 16) + 2^8 * tonumber(rec[5], 16) + 2^16 * tonumber(rec[6], 16) + 2^24 * tonumber(rec[7], 16)
              node = tonumber(rec[3], 16) -- command
              msg = string.format(": <strong>%s</strong>(%i)", cmd[node], pos)
              printf("%+1.3fs %s-TX: CMD(%02Xh)   DAT(%08X)%s", dt, mot, node, pos, msg)
            elseif rec[1] == "RX:" then
              sta = tonumber(rec[2], 16) + 256 * tonumber(rec[3], 16)
              tag = tonumber(rec[8], 16) + 256 * tonumber(rec[9], 16)
              pos = tonumber(rec[4], 16) + 2^8 * tonumber(rec[5], 16) + 2^16 * tonumber(rec[6], 16) + 2^24 * tonumber(rec[7], 16)
              mot = bit.band(bit.rshift(sta, 8), 0x001F)
              mot = string.format("M%02i", mot)
              key = string.format("%s.%s", fn, mot)
              vel = 0
              msg = ""
              node = bit.band(bit.rshift(sta, 1), 0x001F) -- mode
              msg = msg .. string.format(" MODE=%s", mode[node] or node)
              msg = msg .. string.format(" BUSY=%i", bit.tst(sta, 13) and 1 or 0)
              if bit.tst(sta, 0) then
                msg = msg .. string.format(" ALM=%02Xh", tag)
              elseif bit.tst(sta, 15) then
                msg = msg .. string.format(" REJ=%02Xh", tag)
              else
                --msg = msg .. string.format(" LIMITEDN=%i", bit.tst(tag, 13) and 1 or 0)
                --msg = msg .. string.format(" LIMITEDP=%i", bit.tst(tag, 12) and 1 or 0)
                msg = msg .. string.format(" LIMITED=%i", bit.tst(tag, 11) and 1 or 0)
                msg = msg .. string.format(" STALLED=%i", bit.tst(tag, 10) and 1 or 0)
                msg = msg .. string.format(" TRIGGERED=%i", bit.tst(tag, 9) and 1 or 0)
                msg = msg .. string.format(" INMOTION=%i", bit.tst(tag, 8) and 1 or 0)
                msg = msg .. string.format(" DONE=%i", bit.tst(tag, 0) and 1 or 0)
              end
              printf("%+1.3fs %s-RX: STA(%04Xh) DAT(%i) TAG(%04Xh) |%s", dt, mot, sta, pos, tag, msg)
              if not out[key] then
                out[key] = { source = fn, mot = mot, id = key, xmax = 0, ymax = 0 }
                table.insert(out, out[key])
              end
              rec = out[key]
              ts = App:Timestamp(ye, mo, da, tonumber(ho), tonumber(mi), tonumber(sc)) * 1e-7 + tonumber(ms) * 1e-6
              if not rec.ts0 then rec.ts0 = ts end
              table.insert(rec, { ts = ts-rec.ts0, pos = pos, vel = vel, sta = sta, tag = tag })
              if math.abs(pos) > rec.ymax then rec.ymax = math.abs(pos) end
              if math.abs(vel) > rec.ymax then rec.ymax = math.abs(vel) end
              rec.xmax = rec[#rec].ts
            else
              line = line:match("^ATB%s+|%s+(.-)$")
              --print('<span style = "color: grey;"># '..line..'</span>')
            end
          else
            printf('%+1.3fs         <span style = "color: grey;"># %s</span>', dt, line)
          end
        end
      else
        --print("\n")
      end
    end
    print "\n"
    print [[</pre></body></html>]]
    App:ConSave(path.chext(fn, "html"))
  end
  fh:close()
  out.xmax, out.ymax = 0, 0
  for i, rec in ipairs(out) do
    if rec.xmax > out.xmax then out.xmax = rec.xmax end
    if rec.ymax > out.ymax then out.ymax = rec.ymax end
  end
  return out
end


local function select_motor(mot)
  --print(mot)
  mot = mot or Plot.Data[1].id
  Plot.Motor = mot
  Plot:Title(mot)
  local dat = Plot.Data[mot]
  --print(mot)
  local len = #dat
  if len ~= 0 then
    --table.insert(dat, dat[len])   len = len + 1
    --table.insert(dat, 1, dat[1])  len = len + 1
  end
  if not dat.row then
    dat.raw = {}
    dat.raw.pos  = data.deque(len)
    dat.raw.vel  = data.deque(len)
    dat.raw.done = data.deque(len)
    dat.raw.inmo = data.deque(len)
    dat.raw.trig = data.deque(len)
    for i, rec in ipairs(dat) do
      --printf("  | T %9.6f | P%+12.6f | V%+12.6f | %04X |", rec.ts, rec.pos, rec.vel, rec.sta)
      dat.raw.pos :pushlast { x = rec.ts, y = rec.pos }
      dat.raw.vel :pushlast { x = rec.ts, y = rec.vel }
    end
    Plot:Axis(.1 * math.ceil(Plot.Data.xmax / .1), 2 * 20 * math.ceil(Plot.Data.ymax / 20), "", "", "lc")
    Plot:Grid(1, 10, 0.1, 1, "%.1f", "%.1f")
    local ylo = Plot.Meta.YALIGN == 0 and -Plot.Meta.YMAX/ 2 or 0
    local h   = Plot.Meta.YFINE
    for i, rec in ipairs(dat) do
      dat.raw.done:pushlast { x = rec.ts, y = ylo + 0.5*h + h * bit.bit(rec.tag, 0) }
      dat.raw.inmo:pushlast { x = rec.ts, y = ylo + 3.5*h + h * bit.bit(rec.tag, 8) }
      dat.raw.trig:pushlast { x = rec.ts, y = ylo + 2.0*h + h * bit.bit(rec.tag, 9) }
    end
    save(dat, "dat.lua", "return ")
    save(getmetatable(dat.raw.done), "dat.raw.done.lua", "return ")
  end
  Plot.Curves[Plot:Curve("Pos")]  = dat.raw.pos
  Plot.Curves[Plot:Curve("Vel")]  = dat.raw.vel
  Plot.Curves[Plot:Curve("DONE")] = dat.raw.done
  Plot.Curves[Plot:Curve("TRIG")] = dat.raw.trig
  Plot.Curves[Plot:Curve("INMO")] = dat.raw.inmo
end


GUI:Find("PLT").OnMenu = function(self)
  return {
    { Caption = "Save as...", Image = "imgSave",
      OnClick = function()
        local filename = App:PickFile({"PDF Files (*.pdf)", "SVG Files (*.svg)", "All files (*.*)"}, true, Plot.Motor, "pdf")
        Canvas:SaveAs(filename)
      end };
  }
end


local function CurveSet_Click(self)
  button_click()
  select_motor(self:Tag("motor"))
end


local function load_log(fresh)
  button_click()
  local fn = App:PickFile({"DebugView/ATB log files (*.txt)", "Prelud log files (*.csv)", "All files (*.*)"}, false)
  if not fn then return end
  if fresh then Plot.Data = read_data(fn)
  else          Plot.Data = read_data(fn, Plot.Data) end
  local sets = GUI:Find("curve-sets"):DeleteChildren()
  for i, set in ipairs(Plot.Data) do
    sets:CurveSet(nil, nil, nil, nil, nil, set).OnClick = CurveSet_Click
  end
  local n = sets:Children()
  if n > 1 then sets:Child(n):DoClick() end
end


GUI:Find("open-set").OnClick = function(self)
  button_click()
  load_log(true)
end


GUI:Find("add-set").OnClick = function(self)
  button_click()
  load_log(false)
end


--------------------------------------------------------------------------------------
function App:ResetData()
  local len = 100
  local i, c, m = Plot:Curve("DONE")
  self.RawData = data.deque(len)
  local dat = data.filter(model):spline("shemanarev"):flatten(len):data()
  for _, pt in ipairs(dat) do self.RawData:pushlast(pt) end
  Plot.Curves[i] = self.RawData
end


cls()
App:LogClear()
App:Show("Canvas")

]==================================================];
Options ={
};

};

}
